; Marco for ARTA with automated rotary table and polar plot generation (V1.0)
; by Wim Huyghe / Belgium (28/12/2011)
; Many Thanks to Fabian Reimann/ Berlin  for writing Original Macro (loop measurements V. 0.9e)found in ARTA AP8: Repetitive Measurements with script language AutoIT

Global $Paused
HotKeySet("{PAUSE}", "TogglePause")
HotKeySet("{ESC}", "Terminate")

$MacroExists = ProcessList("Macro_for_ARTA_Loop_Measurement.exe")
If $MacroExists[0][0] = 2 Then
	MsgBox(16, "Macro for ARTA", "You can only run one macro at a time. This process will now close.", 10)
	ProcessClose($MacroExists[2][1])
EndIf

#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <ProgressConstants.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <String.au3>
#include <WinApi.au3>
#include <GuiToolTip.au3>
#include <editconstants.au3>
#include <GuiListView.au3>

#region GUI
$Form1_1 = GUICreate("Macro for ARTA", 378, 668, (@DesktopWidth - 378) / 2, (@DesktopHeight - 604) / 2)
$Button1 = GUICtrlCreateButton("Browse...", 16, 64, 75, 25, $WS_GROUP)
$Button2 = GUICtrlCreateButton("Okay - Start ARTA", 64, 624, 243, 33, $WS_GROUP)
$input1 = GUICtrlCreateInput("", 16, 32, 345, 21)
$input2 = GUICtrlCreateInput("", 16, 168, 177, 21)
$input3 = GUICtrlCreateInput("", 16, 224, 177, 21)
$input4 = GUICtrlCreateInput("", 16, 280, 177, 21)
$input5 = GUICtrlCreateInput("", 16, 336, 177, 21)
$Label1 = GUICtrlCreateLabel("", 16, 48, 4, 4)
$Label2 = GUICtrlCreateLabel("Time (in sec) between steps [no automated table]:", 16, 144, 262, 17)
$Label3 = GUICtrlCreateLabel("Filename prefix:", 16, 200, 77, 17)
$Label4 = GUICtrlCreateLabel("Step size (in degrees):", 16, 256, 197, 17)
$Label5 = GUICtrlCreateLabel("Desired number of steps you want to record:", 16, 312, 210, 17)
$Group1 = GUICtrlCreateGroup("Please specify the path to the ARTA.exe", 8, 8, 361, 97)
GUICtrlCreateGroup("", -99, -99, 1, 1)

$Group2 = GUICtrlCreateGroup("Measurement Setup", 8, 120, 361, 289)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
GUICtrlCreateGroup("", -99, -99, 1, 1)


$Group3 = GUICtrlCreateGroup("File Save Options", 8, 424, 361, 185)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")

$Checkbox1 = GUICtrlCreateCheckbox(" Save as PIR.", 16, 448, 97, 17)
$Checkbox2 = GUICtrlCreateCheckbox(" Save as ASCII.", 16, 480, 97, 17)
$Checkbox3 = GUICtrlCreateCheckbox(" Save as CSV.", 16, 512, 97, 17)
$Checkbox4 = GUICtrlCreateCheckbox(" Create overlay for each measurement and save overlays", 16, 544, 297, 17)
$Checkbox5 = GUICtrlCreateCheckbox(" Use an automated rotary table", 16, 368, 297, 17)
$Checkbox6 = GUICtrlCreateCheckbox(" Create and Save Polar Map", 16, 576, 297, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUISetState(@SW_SHOW)

#endregion GUI

#region IniFileInput

If FileExists(@ScriptDir & "\Macro for ARTA.ini") Then
	GUICtrlSetData($input1, IniRead(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Path", "No data!"))
	GUICtrlSetData($input2, IniRead(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Waiting Time", "No data!"))
	GUICtrlSetData($input3, IniRead(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Filename Prefix", "No data!"))
	GUICtrlSetData($input4, IniRead(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Step Size", "No data!"))
	GUICtrlSetData($input5, IniRead(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Number of Steps", "No data!"))
	$Checkbox1status = IniRead(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Checkbox1", "No data!")
	GUICtrlSetState($Checkbox1, $Checkbox1status)
	$Checkbox2status = IniRead(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Checkbox2", "No data!")
	GUICtrlSetState($Checkbox2, $Checkbox2status)
	$Checkbox3status = IniRead(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Checkbox3", "No data!")
	GUICtrlSetState($Checkbox3, $Checkbox3status)
	$Checkbox4status = IniRead(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Checkbox4", "No data!")
	GUICtrlSetState($Checkbox4, $Checkbox4status)
	$Checkbox5status = IniRead(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Checkbox5", "No data!")
	GUICtrlSetState($Checkbox5, $Checkbox5status)
	$Checkbox6status = IniRead(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Checkbox6", "No data!")
	GUICtrlSetState($Checkbox6, $Checkbox6status)
Else
EndIf

#endregion IniFileInput

#region UserInput
While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit

		Case $Button1
			$dialog = FileOpenDialog("open", "C:\", "(ARTA.exe)")
			GUICtrlSetData($input1, $dialog)
		Case $Button2
			$time = GUICtrlRead($input2)
			$timeforsleep = $time * 1000
			$prefix_basic = GUICtrlRead($input3)
			$prefix = StringReplace(StringReplace($prefix_basic, "+", "{+}"), "-", "{-}")
			$prefixComplete = $prefix & "_deg" & "{+}"
			$prefixCompleteScreen = $prefix & "_deg+"
			$stepsize = GUICtrlRead($input4)
			$angle = 0
			$NumberOfMeasurements = GUICtrlRead($input5)
			$ArtaFilePath = GUICtrlRead($input1)
			$Check_Checkbox1 = ControlCommand("Macro for ARTA", "", 20, "IsChecked", "")
			$Checkbox1status = GUICtrlRead($Checkbox1)
			$Check_Checkbox2 = ControlCommand("Macro for ARTA", "", 21, "IsChecked", "")
			$Checkbox2status = GUICtrlRead($Checkbox2)
			$Check_Checkbox3 = ControlCommand("Macro for ARTA", "", 22, "IsChecked", "")
			$Checkbox3status = GUICtrlRead($Checkbox3)
			$Check_Checkbox4 = ControlCommand("Macro for ARTA", "", 23, "IsChecked", "")
			$Checkbox4status = GUICtrlRead($Checkbox4)
			$Check_Checkbox5 = ControlCommand("Macro for ARTA", "", 24, "IsChecked", "")
			$Checkbox5status = GUICtrlRead($Checkbox5)
			$Check_Checkbox6 = ControlCommand("Macro for ARTA", "", 25, "IsChecked", "")
			$Checkbox6status = GUICtrlRead($Checkbox6)
			SaveToIni()
			GUIDelete()
			ExitLoop
	EndSwitch
	CheckInput()
WEnd

#endregion UserInput

Run($ArtaFilePath)
WinWaitActive("Untitled - Arta")
WinMenuSelectItem("Untitled - Arta", "", "&Analysis", "Single-gated smoothed &Frequency response / Spectrum")
WinWait("Smoothed frequency response (Untitled)", "Custom1", 5)

For $loop = 0 To ($NumberOfMeasurements - 1)
	$angle = $loop * $stepsize

	If $angle <> 0 Then
		If $Check_Checkbox5 = 1 Then ; move automated rotary table
			RunWait("RotaryTableSim.exe " & $angle, "", @SW_MAXIMIZE)
		Else ; wait untill user  have moved table
			Sleep($timeforsleep)
		EndIf
	EndIf

	Send("!f")
	Send("!r")
	WinWaitActive("Impulse response measurement")
	Send("!r")
	WinWaitClose("Impulse response measurement")
	ControlClick("Smoothed frequency response (Untitled)", "Custom1", "Button1")

	If $Check_Checkbox1 = 1 Then ; save PIR measurement
		Send("!f")
		Send("s")
		Sleep(300)
		Send($prefixComplete & $angle & ".pir")
		Send("{ENTER}")
		Sleep(300)
	EndIf
	If $Check_Checkbox2 = 1 Then ; save TXT measurement
		Send("!f")
		Send("e")
		Send("a")
		Sleep(300)
		Send($prefixComplete & $angle & ".txt")
		Send("{ENTER}")
		Sleep(300)
	EndIf
	If $Check_Checkbox3 = 1 Then ; save CSV measurement
		Send("!f")
		Send("e")
		Send("c")
		Sleep(300)
		Send($prefixComplete & $angle & ".csv")
		Send("{ENTER}")
		Sleep(300)
	EndIf
	If $Check_Checkbox4 = 1 Then ; save overlay
		Send("!o")
		Send("a")
		Sleep(300)
		;change overlay name
		Send("^m")
		WinWaitActive("FR Overlay Manager")
		$hListView = ControlGetHandle("FR Overlay Manager", "", "SysListView321")
		_GUICtrlListView_ClickItem($hListView, $loop, "left", False, 2)
		Send($prefixComplete & $angle & ".pir") ; set overlay name
		Send("{ENTER}")
		Send("{ENTER}")
	EndIf
Next

;save set of overlays
If $Check_Checkbox4 = 1 Then
	Send("!o")
	Send("s")
	Sleep(300)
	Send($prefix & ".sfo")
	Send("{ENTER}")
EndIf

;go back to main window only
$Windowname = "Smoothed frequency response (" & $prefixCompleteScreen & $angle & ".pir)"
WinClose($Windowname, "") ; close frequency responce window
$Windowname = $prefixCompleteScreen & $angle & ".pir - Arta"
WinWaitActive($Windowname, "") ;wait until impulse responce window is active

;generate polar plot
If $Check_Checkbox6 = 1 Then
	Send("!t") ; menu "Tools"
	Send("d") ; menu item "Directivity Patterns"
	WinWaitActive("Directivity pattern (Untitled.dpf)")
	Send("!f") ; menu "File"
	Send("c") ; menu item "Create Directivity Pattern"
	WinWaitActive("Directivity data definition")
	ControlClick("Directivity data definition", "Load Files", "[ID:1289]")
	Sleep(300)
	Send($prefixComplete & $angle & ".pir") ; select file name
	Send("{ENTER}")
	Sleep(300)
	ControlClick("Directivity data definition", "OK", "[ID:1]")
	Sleep(300)
	Send("!f") ; menu "File"
	Send("s") ; menu item "Save"
	Sleep(300)
	Send($prefix & ".dpf") ; set file name
	Send("{ENTER}")
EndIf

;move rotary table back to zero
If $Check_Checkbox5 = 1 Then ; move automated rotary table
	RunWait("RotaryTableSim.exe 0", "", @SW_MAXIMIZE)
EndIf

#region Functions

Func CheckInput()
	Local $string2 = GUICtrlRead($input2)
	$string2mod = StringRegExpReplace($string2, "[^0-9\.]", "")
	If $string2 <> $string2mod Then MsgBox("64", "Macro for ARTA", "Please enter a digit!" & @CRLF & "You can use a dot (.) as decimal separator character.", 5)
	GUICtrlSetData($input2, $string2mod)

	Local $string4 = GUICtrlRead($input4)
	$string4mod = StringRegExpReplace($string4, "[^0-9\.]", "")
	If $string4 <> $string4mod Then MsgBox("64", "Macro for ARTA", "Please enter a digit!" & @CRLF & "You can use a dot (.)as decimal separator character.", 5)
	GUICtrlSetData($input4, $string4mod)

	Local $string5 = GUICtrlRead($input5)
	$string5mod = StringRegExpReplace($string5, "[^0-9]", "")
	If $string5 <> $string5mod Then MsgBox("64", "Macro for ARTA", "Please enter a digit!", 5)
	GUICtrlSetData($input5, $string5mod)
EndFunc   ;==>CheckInput

Func SaveToIni()
	IniWrite(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Path", GUICtrlRead($input1))
	IniWrite(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Waiting Time", GUICtrlRead($input2))
	IniWrite(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Filename Prefix", GUICtrlRead($input3))
	IniWrite(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Step Size", GUICtrlRead($input4))
	IniWrite(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Number of Steps", GUICtrlRead($input5))
	IniWrite(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Checkbox1", $Checkbox1status)
	IniWrite(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Checkbox2", $Checkbox2status)
	IniWrite(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Checkbox3", $Checkbox3status)
	IniWrite(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Checkbox4", $Checkbox4status)
	IniWrite(@ScriptDir & "\Macro for ARTA.ini", "Section1", "Checkbox5", $Checkbox5status)
EndFunc   ;==>SaveToIni

Func TogglePause()
	$Paused = Not $Paused
	While $Paused
		Sleep(100)
		ToolTip('Macro for ARTA is paused. Hit the button again to continue.', 0, 0)
	WEnd
	ToolTip("")
EndFunc   ;==>TogglePause

Func Terminate()
	Exit 0
EndFunc   ;==>Terminate

#endregion Functions
